/* Fire Control 			by Yoonhee Kim

*/

import java.applet.*;
import java.awt.*;
import java.lang.*;
import java.net.*;
import java.io.*;


         
public class FireControl 
{
    
    public static String[] radar_name = { "MON", "NYC", "ALB", "ROM", "SYR",
                        "ROC", "BUF", "BRA", "BOS", "AEGIS"};

    public static double[][] radar_loc ={{-73.36, 45.30,0}, /* MONTREAL */
                                         {-73.77, 40.63,0}, /* NYC      */
                                         {-73.80, 42.74,0}, /* ALBANY   */
                                         {-75.48, 43.22,0}, /* ROME     */
                                         {-76.10, 43.11,0}, /* SYRACUSE */
                                         {-77.67, 43.11,0}, /* ROCHESTER*/
                                         {-78.73, 42.94,0}, /* BUFFALO  */
                                         {-72.68, 41.93,0}, /* BRADLEY  */
                                         {-71.00, 42.36,0}, /* BOSTON   */
                                         {-72.10, 40.25,0} }; /* AEGIS */

    public static double[][] airbase_loc = {{-74.57, 39.45, 0},  /* AC   */
                                            {-70.56, 41.74, 0}}; /* OTIS */



    public static double[][] ac0_loc ={  {-70.55, 41.15, 660,  0   },  
                                         {-72.22, 41.09, 660,  515 }, /*disappear from here*/
                                         {-72.24, 41.09, 90,   520 },
                                         {-73.92, 40.75, 90,   720 },  /* NYC */
                                         {-75.77, 44.05, 1000, 1800}}; /* Ft. Drum */
                                       
    public static double[][] ac1_loc ={  {-78,    43.8,  10000, 10  },   /* BUFFALO  */  
                                         {-73.94, 40.66, 10000, 1800},
                                         {-72,    40,    10000, 2400}, 
                                         {  0,     0,    0,      0  },
                                         {  0,     0,    0,      0  } };

    public static double[][] ac2_loc ={  {-71.02, 42.33, 5000,  5   }, /* BOSTON   */
                                         {-73.80, 42.66, 5000,  1200}, /* ALBANY   */
                                         {-78.86, 42.89, 5000,  2600}, /* BUFFALO  */ 
                                         {  0,     0,    0,      0  },
                                         {  0,     0,    0,      0  } };

                                         
    public static double[][] ac3_loc ={  {-79.98, 40.44, 10000,  8   }, /*Pittsburgh */
                                         {-76.14, 43.04,  5000,  1800}, /* SYRACUSE  */
                                         {-73.50, 45.51,     0,  3600}, /* Montreal  */
                                         {  0,     0,    0,      0},
                                         {  0,     0,    0,      0} };

    
    public static int ac0_leg=4;
    public static int ac1_leg=2;
    public static int ac2_leg=2;
    public static int ac3_leg=2;

    public static int[]  rflag = {1,1,1,1,1,1,1,1,1,1}; /* radar availibility    */
    public static int[]  airbaseflag = {0, 0};          /* airbase  availibility */
  
    public static int  History = 0;                   /* flag for whole track of AC     */
    public static int  Interceptorflag=0;             /* flag for interceptor           */
    public static int  InterceptorLaunchedflag=0;     /* flag for interceptor launching */
    public static int  KillTargetflag =0;             /* flag for destroying target     */

    public static double maxrange, minelevation;
    public static double[][] ac_cur_location = new double[4][3]; 
    public static double[][][] ac_cur_rae = new double[10][4][3]; 
    public static double[][] Interceptor_location = { /* initial position of interceptor */
                                                      {-74.57, 39.45, 500},   /* AC   */
                                                      {-70.56, 41.74, 500} }; /* OTIS */  
   

    public static int  NUM_AC = 4;       /* number of AC    */
    public static int  NUM_RADAR = 10;   /* number of Radar */
    public static int  NUM_AIRBASE = 2;  /* number of AIRBASE */
    public static int SpeedTimer = 1000;
    
  
 
    ACFrame  ac0, ac1, ac2, ac3;
    Interceptor  Interceptor0, Interceptor1;
    int count;
    ChangeSimTime  Time;
    SimulationFire simulation;
   
    // -- B.Ye , April,20th,98 ----
        protected ServerSocket listen_socket = null;
        protected Socket client;
        protected String server_name = "128.230.61.76" ;  // hardcoded
        int port = 5001;

    public  FireControl()
     {   

        //------------- B.Ye ,  April/20th/98 -----------

            try {
                if (listen_socket == null)
                listen_socket = new ServerSocket(port);
               } 
             catch (IOException e)
               { System.out.println(e + "Exception creating server socket"); }

 
              client = null;
              try {
                  System.out.println("\n Server:" + port + " listening...");
                  client = listen_socket.accept();
               } catch (IOException ie) {
                  System.out.println("Exception while listening for connections");
                  ie.printStackTrace();
               } 
 
               System.out.println("New connection from : " + client.getInetAddress());                     
            // <---- End of socket connection --



         Time = new ChangeSimTime(); 


          ac0 = new ACFrame(ac0_leg,
                           ac0_loc[0][0], ac0_loc[0][1], ac0_loc[0][2], ac0_loc[0][3],
                           ac0_loc[1][0], ac0_loc[1][1], ac0_loc[1][2], ac0_loc[1][3],
                           ac0_loc[2][0], ac0_loc[2][1], ac0_loc[2][2], ac0_loc[2][3],
                           ac0_loc[3][0], ac0_loc[3][1], ac0_loc[3][2], ac0_loc[3][3],
                           ac0_loc[4][0], ac0_loc[4][1], ac0_loc[4][2], ac0_loc[4][3]);

         ac1 = new ACFrame(ac1_leg,
                           ac1_loc[0][0], ac1_loc[0][1], ac1_loc[0][2], ac1_loc[0][3],
                           ac1_loc[1][0], ac1_loc[1][1], ac1_loc[1][2], ac1_loc[1][3],
                           ac1_loc[2][0], ac1_loc[2][1], ac1_loc[2][2], ac1_loc[2][3],
                           ac1_loc[3][0], ac1_loc[3][1], ac1_loc[3][2], ac1_loc[3][3],
                           ac1_loc[4][0], ac1_loc[4][1], ac1_loc[4][2], ac1_loc[4][3]);
         ac2 = new ACFrame(ac2_leg,
                           ac2_loc[0][0], ac2_loc[0][1], ac2_loc[0][2], ac2_loc[0][3],
                           ac2_loc[1][0], ac2_loc[1][1], ac2_loc[1][2], ac2_loc[1][3],
                           ac2_loc[2][0], ac2_loc[2][1], ac2_loc[2][2], ac2_loc[2][3],
                           ac2_loc[3][0], ac2_loc[3][1], ac2_loc[3][2], ac2_loc[3][3],
                           ac2_loc[4][0], ac2_loc[4][1], ac2_loc[4][2], ac2_loc[4][3]);
         ac3 = new ACFrame(ac3_leg,
                           ac3_loc[0][0], ac3_loc[0][1], ac3_loc[0][2], ac3_loc[0][3],
                           ac3_loc[1][0], ac3_loc[1][1], ac3_loc[1][2], ac3_loc[1][3],
                           ac3_loc[2][0], ac3_loc[2][1], ac3_loc[2][2], ac3_loc[2][3],
                           ac3_loc[3][0], ac3_loc[3][1], ac3_loc[3][2], ac3_loc[3][3],
                           ac3_loc[4][0], ac3_loc[4][1], ac3_loc[4][2], ac3_loc[4][3]);
 
/*
 
         r0 = new RFrame(4, radar_loc[0][0], radar_loc[0][1], radar_loc[0][2]);
         r1 = new RFrame(4, radar_loc[1][0], radar_loc[1][1], radar_loc[1][2]);
         r2 = new RFrame(4, radar_loc[2][0], radar_loc[2][1], radar_loc[2][2]);
         r3 = new RFrame(4, radar_loc[3][0], radar_loc[3][1], radar_loc[3][2]);
         r4 = new RFrame(4, radar_loc[4][0], radar_loc[4][1], radar_loc[4][2]);
         r5 = new RFrame(4, radar_loc[5][0], radar_loc[5][1], radar_loc[5][2]);
         r6 = new RFrame(4, radar_loc[6][0], radar_loc[6][1], radar_loc[6][2]);
         r7 = new RFrame(4, radar_loc[7][0], radar_loc[7][1], radar_loc[7][2]);
         r8 = new RFrame(4, radar_loc[8][0], radar_loc[8][1], radar_loc[8][2]);
         r9 = new RFrame(4, radar_loc[9][0], radar_loc[9][1], radar_loc[9][2]);

*/
    
         Interceptor0 = new Interceptor(this, 
                                        Interceptor_location[0][0],
                                        Interceptor_location[0][1],
                                        Interceptor_location[0][2]);


         Interceptor1 = new Interceptor(this,
                                        Interceptor_location[1][0],
                                        Interceptor_location[1][1],
                                        Interceptor_location[1][2]);
         	      
	SimulationFire simulation = new SimulationFire(this);


        /** -------- B.Ye ------>
          System.out.println("Socket value before closing : " + client);

                 try {
                        client.close();
                        System.out.println("closed socket .");
                        System.out.println("Socket value after closing : " + client);
                 }
                 catch(IOException e2) {
                        System.out.println("Thread encountered problem in closing socket.");
                 }  // <--------- **/


       }/* end init() */




static public void main(String[] args)
{
  FireControl f = new FireControl();
}




}/* end class se */




















