//************************************************************
// Name : DBsccess.java
//   access database (mSQL) for CIT table and ACT table 
//
// Modifying History :
//    11th,May,1997 --
//        open VDCE_TABLES for information access 
//
//************************************************************

import java.sql.*;
import java.net.*;
import java.io.*;

class DBacc_SOLARIS {

   Connection  con        = null;    // connection to db
   Statement   s          = null;    // for access database
   String             user_id    = "vdce";  // user id to connect to database
   String             db_url	 = null;    // url of the data base


   public DBacc_SOLARIS(String db_url) {
      try {
         Class.forName("COM.imaginary.sql.msql.MsqlDriver");
         this.db_url    = db_url;
	 String user_id = "vdce";
         con            = DriverManager.getConnection(db_url,user_id, "");
         s              = con.createStatement();   
         }
      catch (SQLException sql) {
         System.out.println ("sql exception");
         sql.printStackTrace();
         }
      catch (Exception e ) {
         System.out.println("exception in start");
         e.printStackTrace();
         }
      }
          
   public DBacc_SOLARIS() {
      try {
         Class.forName("COM.imaginary.sql.msql.MsqlDriver");
         db_url = "jdbc:msql://128.230.61.11:4333/VDCE_TABLES";
	 user_id = "vdce";
         con  = DriverManager.getConnection(db_url,user_id, "");
         s    = con.createStatement();   
         }
      catch (SQLException sql) {
         System.out.println ("sql exception");
         sql.printStackTrace();
         }
      catch (Exception e ) {
         System.out.println("exception in start");
         e.printStackTrace();
         }
      }

   public ResultSet query(String queryString) {
      ResultSet rs = null;
      try {
         rs = s.executeQuery(queryString);
      } catch (SQLException sqle) {
         end();
         System.out.println("exception in sql query");
         sqle.printStackTrace();
      }
      return(rs);
   }

   public void update(String updateString) {
       try {
            s.executeUpdate(updateString);
       }
       catch(SQLException sqle) {
          end();
          System.out.println("exception in sql update!");
          sqle.printStackTrace();
       }
   }   
    
   public void end() {
      try {
         System.out.println("ending connection");
         s.close(); 
         con.close();
         }
      catch (SQLException sqle) {
         System.out.println("close interrupted ");
         sqle.printStackTrace();
         }
      }

/********* test ********
   public static void main(String args[]) {

      ResultSet rs    = null;
      int       count = 0;
 
         DBacc_SOLARIS sqlq = new DBacc_SOLARIS();
***
         rs = sqlq.query("select source_IP,source_TaskNo,source_PortNo,source_LPort,source_socket,dest_IP,dest_TaskNo,dest_PortNo,dest_LPort,dest_socket  from CIT_1000_0001");

       try {
         while(rs.next())  {
          String str1 = rs.getString(1);
          System.out.println(str1);
          String str2 = rs.getString(2);
          System.out.println(str2);
          String str3 = rs.getString(3);
          System.out.println(str3);
          int str3_int = Integer.parseInt(str3);
          System.out.println(str3_int);
          String str4 = rs.getString(4);
          System.out.println(str4);
          String str5 = rs.getString(5);
          System.out.println(str5);
          String str6 = rs.getString(6);
          System.out.println(str6);
          String str7 = rs.getString(7);
          System.out.println(str7);
          String str8 = rs.getString(8);
          System.out.println(str8);
          String str9 = rs.getString(9);
          System.out.println(str9);
          String str10 = rs.getString(10);
          System.out.println(str10);
         } // while
      } catch (SQLException sqle) {
         System.out.println("exception in sql query");
         sqle.printStackTrace();
      }
****

         rs = sqlq.query("SELECT TotalTask from ACT_1000_0001");
         System.out.println("Total task : " );
      try {
          while(rs.next() ) {
          String str1 = rs.getString(1);
          System.out.println(str1);
          }
      } catch (SQLException sqle) {
         System.out.println("exception in sql query");
         sqle.printStackTrace();
      }
        
         rs = sqlq.query("SELECT TaskNo,ModuleID,MachineNum,CompType,MachineIP,MachineHostname,FileName,Role from ACT_1000_0001");

       System.out.println("ACT information: " );
       try {
         while(rs.next())  {
          String str1 = rs.getString(1);
          System.out.println(str1);
          String str2 = rs.getString(2);
          System.out.println(str2);
          String str3 = rs.getString(3);
          System.out.println(str3);
          String str4 = rs.getString(4);
          System.out.println(str4);
          String str5 = rs.getString(5);
          System.out.println(str5);
          String str6 = rs.getString(6);
          System.out.println(str6);
          String str7 = rs.getString(7);
          System.out.println(str7);
          String str8 = rs.getString(8);
          if(str8.startsWith("0")) System.out.println("Role=0");
          System.out.println(str8);
         } // while
      } catch (SQLException sqle) {
         System.out.println("exception in sql query");
         sqle.printStackTrace();
      }
         sqlq.end();
      }
****** test main() ****/

   }
