
// LACS.java
//
// ********************************************************************
//
//  Modifying History:
//  ==================
//
//   ver0.0 : 10th,Feb.,1997
//            * set up the connection to Server through socket
//            * set up the channel through standard IO to DVM
//            * receive information from DVM
//            * pass back the information to Server_CVM
//   ver0.1 : support ver0.1
//   ver0.2 : support ver0.2
//
//   ver1.0 : 23rd, March, 1997 
//            * inserted into servlets in client site
//            * support JSDK1.0
//            * remove "RSH" , use "URL"
//            * limitation : test only on SOLARIS
//                           -- hardcode server name and port# 
//
//     ver1.1 : 30th,March,1997
//          * test on IBM machines 
//          * test paramters passing from master servlet
//
//   ver1.2 : 21st,April,1997
//            * using socket connection to DVM
//
//   ver1.3 : 11th,May,1997
//            * support DataBase access
//
//   ver1.4 : 23rd,May,1997
//            * support socket connection for non - Database Driver
//              case
//
//   ver1.6 : 3rd,Jan.,1998
//            * "stop" functionalities
//            * receive process ID from DVM in CIT_Conf_ACK
//
//   ver2.0 : July, 1998
//            * implement handling ADS process fault
//              if LACS detects a process fault then send a message to 
//                 SACS.
// ********************************************************************


import java.io.*;
import java.net.*;
import java.sql.*;

public class LACS {

	// Declaration of all the variables. 
	Socket s = null;
	DataInputStream sin;
	PrintStream sout = null ;
	Process app_dvm = null;
        String app_id = "1" ;
        String DB_IP = null;
        String DB_port = null;

	int channel_no = 0, mytsk_id = 0, machines = 0;
	String[] host = null, path_file = null;
        static String server_name = null ;
        static int    port = 0;
	String[] tasknm =null; 
	String[] datatyp =null; 
	String[] s_IP=null,d_IP =null; 
	String[] s_pid=null,d_pid =null; 
	String[] s_port=null,d_port =null; 
	String[] s_tkid=null,d_tkid=null;
	String[] s_sock=null,d_sock =null; 
/*data representation -- Yoonhee */
	String[] s_data_rep=null,d_data_rep =null; 
	String Result_Path;
	InetAddress local_addr;
        /*****
	FileOutputStream main_out; 
        PrintStream Lcvm_log = null ;
        *****/

        String DVM_proc_id = null;

       // server socket to DVM
            ServerSocket serv=null; 
            Socket channel =null ;
            String header_to_DVM=null;
            DataInputStream read_in=null;
            PrintStream write_out=null;

            String user_ID = null ;
            String app_ID = null ;
            String DVM_port = null ;
            String DVM_pid = null;

            String time_unit = null ;
            String exc_time = null ;
     
            //cur_time get_cur_time = null;

     // *************************************************
     //  constructor
     // *************************************************

	public LACS(String server_name_par,String port_str,String user_ID_par,String app_ID_par,String task_id_par,String DVM_port_par,String DB_IP,String DB_port) {
                server_name = server_name_par; 
                port = Integer.parseInt(port_str);
                user_ID = user_ID_par;
                app_ID = app_ID_par;
                mytsk_id = Integer.parseInt(task_id_par);
                DVM_port = DVM_port_par ;
                this.DB_IP = DB_IP;
                this.DB_port = DB_port;
              
                System.out.println("====Information from server for task " + mytsk_id +"====");
                System.out.println(" server : " + server_name + " port:" + port);
                System.out.println(" user_ID : " + user_ID);
                System.out.println(" app_ID : " + app_ID);
                System.out.println(" DVM_port : " + DVM_port);
                System.out.println(" DB_IP : " + DB_IP);
                System.out.println(" DB_Port : " + DB_port);
                System.out.println("================ for task " + mytsk_id +"===============");

           /**************
                try{
                  main_out = new FileOutputStream("Lcvm_" + mytsk_id + ".log");
                  PrintStream Lcvm_log = new PrintStream(main_out);
                } catch(IOException ioe) { System.out.println(ioe);
                   ioe.printStackTrace();
                  }
            ***************/
      
	}


     //  *****************************************************
     //  check_stop() -- check if ther is signal for stopping
     //    if positive -- destroy current servlet
     //  *****************************************************
         public int check_stop() {
          FileInputStream in = null;

          String addr = "/tmp/stop_" + user_ID + "_" + app_ID + "_vdce";

          try {
           in = new FileInputStream(addr);
          } catch(FileNotFoundException e) { System.out.println(e); }

          try {
           if(in.read() == 'S')  {  //"STOP"
             System.out.println("*****STOP**** signals recieved by Local-CVM...");
             return(-1); 
           }
           //else System.out.println("signal:run");

           in.close();
          } catch(IOException e) { System.out.println(e); }

          return(0);
         }

     //  *****************************************************
     //  check_stop_DVM() -- check if ther is signal for stopping
     //    if positive -- send signals to DVM and destroy current servlet
     //  *****************************************************
         public int check_stop_DVM() {
           FileInputStream in = null;
 
           String addr = "/tmp/stop_" + user_ID + "_" + app_ID + "_vdce";
         try{
           in = new FileInputStream(addr);
         } catch(FileNotFoundException e) { System.out.println(e); }
         try {
           if(in.read()=='S' ) {
             System.out.println("sending 'stop' signals to DVM...");
             /**send_stop(); 
             System.out.println("waiting 'stop' ACK from DVM...");
             stop_ACK(); ***/
             return(-1);
           }
           //else System.out.println("signal:run");
           in.close();
          } catch(IOException e) { System.out.println(e); }

         return(0);

         }


     //  ***********************************************
     //      work() 
     //  ***********************************************

	public int work() {

        	Startup_Check();

//                get_cur_time = new cur_time(user_ID,app_ID,mytsk_id);
//                get_cur_time.work();

        	Connect_Server(port);

                Read_CIT(); 

                Read_ACT();

                set_procgroup(); 

        	Read_Server_Info();

                set_socket_DVM();

        	Start_DVM_APP();

                close_socket();

                return(0);
	}	

      //*************************************************
      //   Startup_Check()
      //*************************************************

	public int Startup_Check() {
                System.out.println("\n Startup_Check for task " + mytsk_id + " is called!");
                try {
		   FileOutputStream f_out = new FileOutputStream("triggerLCVM.log_"+mytsk_id);
		   PrintStream ff1 = new PrintStream(f_out);
                   ff1.println("Local CVM has been triggered!");
                   ff1.println("Local invoked! \n");
                   ff1.close();

                   // Lcvm_log.println("Local cvm has been triggered!");
                } catch(IOException e) {return(-1);}
                return(1);
        }


       //****************************************************
       // Connect to Server
       //****************************************************

	public int Connect_Server(int port) { 
 
		String local_name;

                System.out.println("\n Connection_Server() is called.");
                try {
                   
		    local_addr = java.net.InetAddress.getLocalHost();
		    s = new Socket(server_name, port);  
                    System.out.println("======= task " + mytsk_id + " connect to server : =========");
                    System.out.println(server_name + " " + port); 
		    System.out.println(s.getInetAddress() + ","+ s.getPort());
                    System.out.println("From:" + java.net.InetAddress.getLocalHost().toString());
                    System.out.println("====================================");
                } catch (IOException ioe) {
                   System.out.println("exception in logging to file");
                   ioe.printStackTrace();
                //} catch (UnknownHostException uhe) {
                   //System.out.println("exception in logging to file");
                   //uhe.printStackTrace();
                }
		return(1);
	}

       // *******************************************************
       //   Read Server information
       // *******************************************************

	public void Read_Server_Info() {

		// Reading task_id info. from Socket
                System.out.println("\n Read_Server_Info() is called . ");
                // Lcvm_log.println("\n Start to read information from server_cvm...");

            try {
	  	   sin = new DataInputStream(s.getInputStream()); 

            } catch (IOException ioe) {
               System.out.println("IO Error");
               ioe.printStackTrace();
              }
 
        
        }


      // ***************************************************
      // Read CIT information from mSQL
      // ***************************************************
      
      public void Read_CIT() {

        ResultSet rs = null;
        DBacc_SOLARIS sqlq = new DBacc_SOLARIS("jdbc:msql://" + DB_IP + ":" + DB_port + "/VDCE_TABLES");

               rs = sqlq.query("SELECT TotalChannel FROM CIT_" + user_ID + "_" +app_ID);

               try {
                 while(rs.next()) {
		   channel_no  = Integer.parseInt(rs.getString(1)); 
                 }
	       }  catch (SQLException sqle) {
               sqlq.end();
               System.out.println("execption in sql query for Channel# ");
               sqle.printStackTrace();
               }
               sqlq.end();

		   System.out.print("channel_no : ");                 
		   System.out.println(channel_no);                 

		   tasknm  = new String[channel_no];
		   datatyp = new String[channel_no];
		   s_IP	= new String[channel_no];
		   d_IP 	= new String[channel_no];
		   s_pid	= new String[channel_no];
		   d_pid 	= new String[channel_no];
		   s_port	= new String[channel_no];
		   d_port  = new String[channel_no];
		   s_tkid  = new String[channel_no]; 
		   d_tkid  = new String[channel_no];
		   s_sock  = new String[channel_no];
		   d_sock  = new String[channel_no];
/*data representation -- Yoonhee */
		   s_data_rep  = new String[channel_no];
		   d_data_rep  = new String[channel_no];

           
              sqlq = new DBacc_SOLARIS("jdbc:msql://" + DB_IP + ":" + DB_port + "/VDCE_TABLES");
               rs= sqlq.query("SELECT variable_name,variable_type,source_IP,source_PortNo,source_LPort,source_TaskNo,source_socket,dest_IP,dest_PortNo,dest_LPort,dest_TaskNo,dest_socket, source_data_rep, dest_data_rep FROM CIT_" + user_ID + "_" + app_ID);
 
                try {
                   int kj=0;
                   while(rs.next()) {
			tasknm[kj]	= rs.getString(1); 
			datatyp[kj]	= rs.getString(2); 
			s_IP[kj]	= rs.getString(3); 
			s_pid[kj]	= rs.getString(4); 
			s_port[kj]	= rs.getString(5); 
			s_tkid[kj]	= rs.getString(6); 
			s_sock[kj]	= rs.getString(7); 
			d_IP[kj]	= rs.getString(8); 
			d_pid[kj]	= rs.getString(9); 
			d_port[kj]	= rs.getString(10); 
			d_tkid[kj]	= rs.getString(11); 
			d_sock[kj]	= rs.getString(12); 
/* DATA REPESENTATION -- Yoonhee */
			s_data_rep[kj]	= rs.getString(13); 
			d_data_rep[kj]	= rs.getString(14); 
                        kj++;
                    }
	       } catch (SQLException sqle) {
               sqlq.end();
               System.out.println("execption in sql query for CIT ");
               sqle.printStackTrace();
               }

             sqlq.end();

    }


      // ***************************************************
      //  Read ACT information from mSQL
      // ****************************************************
      

       public void Read_ACT() {
         ResultSet rs = null;
         DBacc_SOLARIS sqlq = new DBacc_SOLARIS("jdbc:msql://" + DB_IP + ":" + DB_port + "/VDCE_TABLES");

          rs = sqlq.query("SELECT TaskNo,MachineNum FROM ACT_" + user_ID + "_" + app_ID);
		   System.out.print("mytsk_id : ");                 
		   System.out.println(mytsk_id);                 

                try {
                    int id = 0 ;
                    while(rs.next()) {
                     id = Integer.parseInt(rs.getString(1));
                     if(id==mytsk_id) {
                	     machines    = Integer.parseInt(rs.getString(2)); 
//                             break;
                     }
                    }
	       } catch (SQLException sqle) {
               sqlq.end();
               System.out.println("execption in sql query for machine# ");
               sqle.printStackTrace();
               }
               sqlq.end();
                
		   System.out.print("machines : ");                 
		   System.out.println(machines);                 

		   host	= new String[machines];
		   path_file= new String[machines];

         sqlq = new DBacc_SOLARIS("jdbc:msql://" + DB_IP + ":" + DB_port + "/VDCE_TABLES");
          rs = sqlq.query("SELECT TaskNo,MachineHostname,FileName FROM ACT_" + user_ID + "_" + app_ID);

              try {
                   int jj=0;
                   int id=0;
                   while(rs.next() ) {
                        id = Integer.parseInt(rs.getString(1));
                       if(id==mytsk_id) {
			host[jj]   = rs.getString(2);
			path_file[jj]  = rs.getString(3);
                        jj++;
                       }
                   }
	       } catch (SQLException sqle) {
               sqlq.end();
               System.out.println("execption in sql query for machine# ");
               sqle.printStackTrace();
               }

           sqlq.end();

      }


      // ***************************************************
      //  set up procgroup file 
      // ***************************************************

      public void set_procgroup() {
 
//		   Result_Path = "/merlin2/users/demo/vdce/ver1/db/PG_";
		   Result_Path = "/tmp/PG_";

                   System.out.println("path_file 0 is " + path_file[0]);
		   if( path_file[0].endsWith("INV") )  
                       Result_Path = Result_Path.concat("INV_");
		   if( path_file[0].endsWith("MULT") ) 
                       Result_Path = Result_Path.concat("MULT_");
		   if( path_file[0].endsWith("LU") ) 
                       Result_Path = Result_Path.concat("LU_");

	   Result_Path = Result_Path.concat(user_ID + "_" + app_ID + "_");
	   Result_Path = Result_Path.concat(Integer.toString(mytsk_id));
           System.out.println("result path for task#" + mytsk_id + " :" + Result_Path);

          try {
		   FileOutputStream proc_out = new FileOutputStream(Result_Path);
		   PrintStream ff1 = new PrintStream(proc_out);
                   ff1.println("local 0");
		   for (int jj=0;jj<machines;jj++) 
                        ff1.println(host[jj] + "\t 1 \t" + path_file[jj]);
		   ff1.close();
          } catch (IOException ioe) {
               System.out.println("IO Error");
               ioe.printStackTrace();
            }

     }


      // ***************************************************
      // set up server socket to DVM
      // ****************************************************
         public void set_socket_DVM() {

	    try{
                serv = new ServerSocket(Integer.parseInt(DVM_port));
                System.out.println("\n local cvm to DVM server for task# " + mytsk_id + " socket set up!");
                // Lcvm_log.println("\n local cvm to DVM server for task " + mytsk_id + " socket is set up!");
             }
             catch(IOException e) {
		System.out.println
                ("\n A fault has been detected from Task(ADS) id " + mytsk_id);
                System.out.println
                ("Exception when create server socket from local_cvm to DVM."
                 + e );  
	    } // catch
           } // try


       // ********************************************************
       //  set up the header sent to DVM
       // *******************************************************
          public void set_header() {
            InetAddress local_addr;
            String local_name=null;
            String machine_name = null;
            int index=0;

           // ---- header sent to DVM

            System.out.println("======Header for task# " + mytsk_id + " : ======");
            header_to_DVM= "VDCE";
            System.out.println(header_to_DVM);
            header_to_DVM= header_to_DVM.concat("4000");
            System.out.println(header_to_DVM);
            header_to_DVM= header_to_DVM.concat("0000000000");
            System.out.println(header_to_DVM);
            header_to_DVM= header_to_DVM.concat("0001"); //user_ID
            System.out.println(header_to_DVM);
            header_to_DVM= header_to_DVM.concat("0001");  //app_ID
            System.out.println(header_to_DVM);

            for(int i=1; i<=(3-Integer.toString(mytsk_id).length()); i++)
             header_to_DVM= header_to_DVM.concat("0");
            header_to_DVM= header_to_DVM.concat(Integer.toString(mytsk_id));
            System.out.println(header_to_DVM);
            // Lcvm_log.println(header_to_DVM);

           try {
            local_addr = java.net.InetAddress.getLocalHost();
            local_name = local_addr.toString();
            char[] local_name_ch = local_name.toCharArray();

//            for(int i=0;i<local_name.length();i++) 
//              if(java.lang.Charavter.isDigit(local_name_ch[i])) { index=i; break; }
            
            } catch(UnknownHostException e) {
                  System.out.println("Error when get the local address in local CVM: " + e );
              }

            
//            machine_name = local_name.substring(index,local_name.length()-index);
            machine_name = "128.196.28.79.";
            machine_name = machine_name.concat(DVM_port);
            header_to_DVM = header_to_DVM.concat(machine_name);
            for(int i= machine_name.length();i<21;i++) 
             header_to_DVM = header_to_DVM.concat("*");
            System.out.println(header_to_DVM);
            System.out.println("=====Header for task " + mytsk_id + " end ======");
            

          }



        // ********************************************************
        // send CIT to DVM
        // ********************************************************
           public void send_CIT() {
            String header_to_DVM1=null ;
            String data_block=null;
            int len = 0 ;

		// send CIT to DVM
            try
               {
                read_in = new DataInputStream(channel.getInputStream());
                write_out = new PrintStream(channel.getOutputStream());

                System.out.println("Local_cvm" + mytsk_id + " starts to send informaiton to DVM");

           for(int jk=0;jk<channel_no;jk++) {

                        len=58;
                        len += 5;  // for the command and new line
                        len += user_ID.length()+app_ID.length()+2; //user_ID, appID and new line

                        len += tasknm[jk].length();
			len += datatyp[jk].length();
			len += s_IP[jk].length();
			len += s_pid[jk].length();
			len += s_port[jk].length();
			len += s_tkid[jk].length();
			len += s_sock[jk].length();
			len += d_IP[jk].length();
			len += d_pid[jk].length();
			len += d_port[jk].length();
			len += d_tkid[jk].length();
			len += d_sock[jk].length();
/*data representation -- Yoonhee */
			len += s_data_rep[jk].length();
			len += d_data_rep[jk].length();
			
                        len += 13;  // for new line attached to each items

                        //len += 11;  // for new line attached to each items

                        int len_len,n; 
                        len_len = Integer.toString(len).length();
            System.out.println("data length of CIT information for task "+ mytsk_id + " : ");
                        System.out.println(len);
                        len_len = 8 - len_len;
           if(len_len!=0) {
            header_to_DVM1 = header_to_DVM.concat("0");
             for(n=1;n<len_len;n++)
              header_to_DVM1 = header_to_DVM1.concat("0");
             header_to_DVM1 = header_to_DVM1.concat(Integer.toString(len));
            }
            else
            header_to_DVM1 = header_to_DVM.concat(Integer.toString(len));

                System.out.println("header of CIT data:");
                System.out.println(header_to_DVM1);
                // Lcvm_log.println(header_to_DVM1);

                write_out.print(header_to_DVM1);

                data_block = "0001\n";  // CIT command
                data_block = data_block.concat(user_ID + "\n");  // user id
                data_block = data_block.concat(app_ID + "\n");  // app id

		data_block = data_block.concat(tasknm[jk]+"\n");
		data_block = data_block.concat(datatyp[jk]+"\n");
		data_block = data_block.concat(s_IP[jk]+"\n");
		data_block = data_block.concat(s_pid[jk]+"\n");
		data_block = data_block.concat(s_port[jk]+"\n");
		data_block = data_block.concat(s_tkid[jk]+"\n");
		data_block = data_block.concat(s_sock[jk]+"\n");
/*data representation -- Yoonhee */
		data_block = data_block.concat(s_data_rep[jk]+"\n");
		data_block = data_block.concat(d_IP[jk]+"\n");
		data_block = data_block.concat(d_pid[jk]+"\n");
		data_block = data_block.concat(d_port[jk]+"\n");
		data_block = data_block.concat(d_tkid[jk]+"\n");
		data_block = data_block.concat(d_sock[jk]+"\n");
/*data representation -- Yoonhee */
		data_block = data_block.concat(d_data_rep[jk]);

                write_out.print(data_block);

                System.out.println("CIT table sent to DVM:");
                System.out.print("0001 ");   // CIT command
                        System.out.print(user_ID + " ");  // user id
                        System.out.print(app_ID + " ");  // app id
			System.out.print(tasknm[jk]+ " ");
			System.out.print(datatyp[jk]+" ");
			System.out.print(s_IP[jk]+" ");
			System.out.print(s_pid[jk]+" ");
			System.out.print(s_port[jk]+" ");
			System.out.print(s_tkid[jk]+" ");
			System.out.print(s_sock[jk]+" ");
// data representation -- Yoonhee
			System.out.print(s_data_rep[jk]+" ");
			System.out.print(d_IP[jk]+" ");
			System.out.print(d_pid[jk]+" ");
			System.out.print(d_port[jk]+" ");
			System.out.print(d_tkid[jk]+" ");
			System.out.println(d_sock[jk]+" ");
// data representation -- Yoonhee
			System.out.print(d_data_rep[jk]);

                 write_out.flush();

	        } //for

             } //try
             catch (Exception e) { System.out.println(e); }
             write_out.flush();

        }



      //******************************************************
      //   receive ACK from DVM
      //*****************************************************

      public void recv_ACK(){
            String dvm_signal = null;

               //****** receiving ACK from DVM *******

           /********** header check
           try {
              while(true) {
               dvm_signal = read_in.readLine();
               if( (dvm_signal!=null) && (dvm_signal.length()>50) ) {
                 System.out.println("DVM ACK from task " + mytsk_id + ":"+dvm_signal);
                  // Lcvm_log.println("DVM ACK : " + dvm_signal);
                 break;
               }
              }
            } catch(IOException e)
              { System.out.println("Error when receive information from DVM: " + e); }


               int signal = 1 ;
               if(!(dvm_signal.substring(0,4).equals("VDCE")) ) {
                System.out.println(dvm_signal.substring(0,4));
                System.out.println("message received is not VDCE message!");
                signal = 0;  }
               else if( !(dvm_signal.substring(4,8).equals("5000")) )  {
                System.out.println(dvm_signal.substring(4,8));
                System.out.println("message is not from DVM!");
                signal = 0;
                }
                    else if( !(dvm_signal.substring(58,61).equals("0002")) ) {
//                          System.out.println(dvm_signal.substring(58,dvm_signal.length()) );
                          System.out.println(dvm_signal.substring(58,61));
//                          System.out.println("Not activation message!");
//                          signal=0;
//                          return;
                         }
            ****************/
                     
           String str = null;
            try{
               int line;
               line = Integer.parseInt(read_in.readLine());
               System.out.println("Number of datus:"+line);
               // Lcvm_log.println("Number of datus: " + line);
               for(int i=1;i<=line;i++) {
               str = read_in.readLine();
               System.out.println(str);
               // Lcvm_log.println(str);
               }
            } catch(IOException e)
              { System.out.println("Error when receive information from DVM: " + e); }
               DVM_pid = str;
               System.out.println("DVM pid: " + DVM_pid);

       }

               
      //****************************************************
      // send Activation to DVM
      //***************************************************
        public void send_ACTIVATION() {
          String header_to_DVM2 = null;
          int len;

               //********   send Activation to DVM *******

                    System.out.println("Local_CVM send activation to DVM");

           len = 58 ;
           len += 5+user_ID.length()+app_ID.length()+2;
           len += Integer.toString(mytsk_id).length();
           int len_len;
            len_len = 8-Integer.toString(len).length();
           if(len_len>0) {
              header_to_DVM2=header_to_DVM.concat("0");
             for(int i=1;i<len_len;i++) 
              header_to_DVM2 = header_to_DVM2.concat("0"); 
             header_to_DVM2 = header_to_DVM2.concat(Integer.toString(len));
            }
            else 
             header_to_DVM2 = header_to_DVM.concat(Integer.toString(len));
 
           try {
                write_out.print(header_to_DVM2);

                String data="0003\n";
                data = data.concat(user_ID + "\n");
                data = data.concat(app_ID+"\n");
                data = data.concat(Integer.toString(mytsk_id));   
                write_out.print(data);

                System.out.println(header_to_DVM2);
                System.out.println("0003");   
                System.out.println(user_ID);   
                System.out.println(app_ID);   
                System.out.println(Integer.toString(mytsk_id));   

             /*************
                Lcvm_log.println(header_to_DVM2);
                Lcvm_log.println("0003");   
                Lcvm_log.println(user_ID);   
                Lcvm_log.println(app_ID);   
                Lcvm_log.println(Integer.toString(mytsk_id));   
               ************/

             } //try
             catch (Exception e) { System.out.println(e); }
             write_out.flush();
         }


        //*****************************************************
        // DVM report after send-receive between DVM starting
        //*****************************************************
           public void recv_dvm_comm() {
            String dvm_signal = null;
            int inf_no = 0 ;

               //****** receiving DVM_send_recv from DVM *******
       /****** header check

		   if( path_file[0].endsWith("INV") )  
                      inf_no = 1 ; 
		   if( path_file[0].endsWith("MULT") ) 
                      inf_no = 2 ; 
		   if( path_file[0].endsWith("LU") ) 
                      inf_no = 1 ; 

        for(int repeat=1;repeat<=inf_no;repeat++) {

           try {

              while(true) {
               dvm_signal = read_in.readLine();
               if( (dvm_signal!=null) && (dvm_signal.length()>50) ) {
                 System.out.println("DVM_send_recv from task " + mytsk_id + ":"+dvm_signal);
                 //Lcvm_log.println("DVM send_recieve signal : " + dvm_signal);
                 break;
               }
              }
            } catch(IOException e)
              { System.out.println("Error when receive information from DVM: " + e); }


               int signal = 1 ;
               if(!(dvm_signal.substring(0,4).equals("VDCE")) ) {
                System.out.println(dvm_signal.substring(0,4));
              //  System.out.println("message received is not VDCE message!");
                signal = 0;  }
               else if( !(dvm_signal.substring(4,8).equals("5000")) )  {
                System.out.println(dvm_signal.substring(4,8));
               // System.out.println("message is not from DVM!");
                signal = 0;
                }
                    else if( !(dvm_signal.substring(58,dvm_signal.length()).equals("0012")) ) {
                          System.out.println(dvm_signal.substring(58,dvm_signal.length()) );
//                          System.out.println(dvm_signal.substring(58,61));
//                          System.out.println("Not dvm_send_recv message!");
//                          signal=0;
//                          return;
                         }
            *****************/
                     
            try{
               String str = null;
               int line;
               line = Integer.parseInt(read_in.readLine());
               System.out.println("Number of datus:"+line);
               //Lcvm_log.println("Number of datus: " + line);
               for(int i=1;i<=line;i++) {
               str = read_in.readLine();
               System.out.println(str);
               //Lcvm_log.println(str);
               }
               DVM_proc_id = read_in.readLine();

            } catch(IOException e)
              { System.out.println("Error when receive information from DVM: " + e); }
        /**** part of header check
          } // for
        **********/

       }

  
        //*****************************************************
        // receive execution time information from DVM
        //*****************************************************
          public void recv_time() {
           String dvm_signal = null ;

           System.out.println("Waiting for time information for task " + mytsk_id + "...");
           //Lcvm_log.println("Waiting for time information ....");

       /**** header check
           try {
             while(true) {
              try {
                   Thread.sleep(5000);
                   Thread.yield();
                  } catch(InterruptedException e) {
                     System.out.println(e); } 

              dvm_signal = read_in.readLine();
              if( (dvm_signal!=null) && (dvm_signal.length()>50) ) {
               System.out.println("time information received for task " + mytsk_id + " : " + dvm_signal); 
              //Lcvm_log.println(" time information received : " + dvm_signal);
               break;
              } // if 
             } //while
          } catch(IOException e)
              { System.out.println("Error when receive time from DVM for task " + mytsk_id + ": " + e); }

               if( dvm_signal.substring(0,4).equals("VDCE")  ) 
                if( dvm_signal.substring(4,8).equals("5000") )  
                    if(!dvm_signal.substring(58,62).equals("0201"))
                     {
//                       System.out.println("this is not exc time from DVM from DVM for task " + mytsk_id + ": ");
//                     return;
                      }
          *******/

            try {
               String str=null;
               int line = Integer.parseInt(read_in.readLine());
               System.out.println("number of data:" + line);
               for(int i=1;i<=3;i++) {
                System.out.println(read_in.readLine());
                //Lcvm_log.println(read_in.readLine());
               }
               
               time_unit = read_in.readLine().toString();
               exc_time = read_in.readLine().toString();
               System.out.println("time:"+exc_time+" unit:"+time_unit);
               System.out.println("length of time_unit,exc_time:" + time_unit.length()+"," + exc_time.length());
               //Lcvm_log.println("time:"+exc_time+" unit:"+time_unit);
               //Lcvm_log.println("length of time_unit,exc_time:" + time_unit.length()+"," + exc_time.length());
          } catch(IOException e)
              { System.out.println("Error when receive time from DVM for task " + mytsk_id + ": " + e); }

         //-- time information received from DVM ---
                try {
                   FileOutputStream f_out = new FileOutputStream("time_tsk"+mytsk_id);
                   PrintStream ff1 = new PrintStream(f_out);
                   ff1.println("execution time: " + exc_time + "\n");
                   ff1.close();
                } catch(IOException e) { System.out.println("Error:" + e); }

   }


       //******************************************************
       // send back confirmation of time information to DVM
       //******************************************************
         public void send_confm(){
          String header_to_DVM4=null ;
            int len;
 
               //******   send respond "execution time information" back to DVM
           System.out.println("Local_CVM send time_confirmation to DVM for task # " + mytsk_id + "...");
           len = 58 ;
           len += 5 + user_ID.length() + app_ID.length() + 2;
           len += Integer.toString(mytsk_id).length();
           int len_len;
            len_len = 8-Integer.toString(len).length();
           if(len_len>0) {
              header_to_DVM4=header_to_DVM.concat("0");
             for(int i=1;i<len_len;i++)
              header_to_DVM4 = header_to_DVM4.concat("0");
             header_to_DVM4 = header_to_DVM4.concat(Integer.toString(len));
            }
            else
             header_to_DVM4 = header_to_DVM.concat(Integer.toString(len));
 
           try {
                write_out.print(header_to_DVM4);
                String data = "0301\n"; // time response code
                data = data.concat(user_ID + "\n");
                data = data.concat(app_ID + "\n");
                data = data.concat(Integer.toString(mytsk_id));
 
                write_out.print(data);
             } //try
             catch (Exception e) { System.out.println(e); }
             write_out.flush();

         }

        //******************************************************
        // receive "complete signal from DVM
        // ****************************************************
           public void recv_cmplt() {
            String dvm_signal = null ;

         /********* header check 
           try {
               while(true) {
                dvm_signal = read_in.readLine();
                if(dvm_signal.length()>50) {
                    System.out.println("Complete sigan from DVM fro task " + mytsk_id + " is received: " + dvm_signal);
                    //Lcvm_log.println("Complete signal from DVM fro task " + mytsk_id + " is received: " + dvm_signal);
                    break;
                }
               } //while
          } catch(IOException e)
              { System.out.println("Error when receive information from DVM: " + e); }
               

               if( dvm_signal.substring(0,4).equals("VDCE")  ) 
                if( dvm_signal.substring(4,8).equals("5000") )  
                    if( !(dvm_signal.substring(dvm_signal.length()-4,dvm_signal.length()).equals("0009")) )  
                    {
//                     System.out.println("message received from DVM is not  'complete' ");
//                     return;
                    }
           **************/


          try {
               String str=null;
               int line = Integer.parseInt(read_in.readLine());
               System.out.println("number of datus:" + line);
               //Lcvm_log.println("number of datus:" + line);
               for(int i=1;i<=line;i++) {
                System.out.println(read_in.readLine());
                //Lcvm_log.println(read_in.readLine());
               }

          } catch(IOException e)
              { System.out.println("Error when receive information from DVM: " + e); }


     }

     //********************************************************
     // send "complete" back to DVM
     //*******************************************************
     public void send_cmplt() {
            String header_to_DVM3=null ;
            int len;

               //******   send respond "completion" back to DVM
                    System.out.println("Local_CVM send completion to DVM for task # " + mytsk_id + "...");
           len = 58 ;
           len += 5 + user_ID.length() + app_ID.length() + 2;
           len += Integer.toString(mytsk_id).length();
           int len_len;
            len_len = 8-Integer.toString(len).length();
           if(len_len>0) {
              header_to_DVM3=header_to_DVM.concat("0");
             for(int i=1;i<len_len;i++) 
              header_to_DVM3 = header_to_DVM3.concat("0"); 
             header_to_DVM3 = header_to_DVM3.concat(Integer.toString(len));
            }
            else 
             header_to_DVM3 = header_to_DVM.concat(Integer.toString(len));
 
           try {
                write_out.print(header_to_DVM3);
                String data = "0009\n"; // completion code
                data = data.concat(user_ID + "\n");
                data = data.concat(app_ID + "\n");
                data = data.concat(Integer.toString(mytsk_id));   

                write_out.print(data);
             } //try
             catch (Exception e) { System.out.println(e); }
             write_out.flush();

       }


     //********************************************************
     // send "STOP" signal to DVM
     //*******************************************************
     public void send_stop() {
            String header_to_DVM4 = null ;
            int len;

               //******   send signal "stop" back to DVM
           System.out.println("Local_CVM send 'stop' signal to DVM for task # " + mytsk_id + "...");
           len = 58 ;
           len += 5 + user_ID.length() + app_ID.length() + 2;
           len += Integer.toString(mytsk_id).length();
           int len_len;
            len_len = 8-Integer.toString(len).length();
           if(len_len>0) {
              header_to_DVM4=header_to_DVM.concat("0");
             for(int i=1;i<len_len;i++) 
              header_to_DVM4 = header_to_DVM4.concat("0"); 
             header_to_DVM4 = header_to_DVM4.concat(Integer.toString(len));
            }
            else 
             header_to_DVM4 = header_to_DVM.concat(Integer.toString(len));
 
           try {
                write_out.print(header_to_DVM4);
                String data = "0005\n"; // "stop" code
                data = data.concat(user_ID + "\n");
                data = data.concat(app_ID + "\n");
                data = data.concat(Integer.toString(mytsk_id));   

                write_out.print(data);
             } //try
             catch (Exception e) { System.out.println(e); }
             write_out.flush();

       }



        //******************************************************
        // receive "stop_ACK" signal from DVM
        // ****************************************************
           public void stop_ACK() {
            String dvm_signal = null ;

         /********* header check 
           try {
               while(true) {
                dvm_signal = read_in.readLine();
                if(dvm_signal.length()>50) {
                    System.out.println("Complete signal from DVM from task " + mytsk_id + " is received: " + dvm_signal);
                    //Lcvm_log.println("Complete signal from DVM from task " + mytsk_id + " is received: " + dvm_signal);
                    break;
                }
               } //while
          } catch(IOException e)
              { System.out.println("Error when receive information from DVM: " + e); }
               

               if( dvm_signal.substring(0,4).equals("VDCE")  ) 
                if( dvm_signal.substring(4,8).equals("5000") )  
                    if( !(dvm_signal.substring(dvm_signal.length()-4,dvm_signal.length()).equals("0006")) )  
                    {
//                     System.out.println("message received from DVM is not  'complete' ");
//                     return;
                    }
           **************/


          try {
               String str=null;
               int line = Integer.parseInt(read_in.readLine());
               System.out.println("number of datus:" + line);
               //Lcvm_log.println("number of datus:" + line);
               for(int i=1;i<=line;i++) {
                System.out.println(read_in.readLine());
                //Lcvm_log.println(read_in.readLine());
               }

          } catch(IOException e)
              { System.out.println("Error when receive 'stop' ACK from DVM: " + e); }


     }

       // ***********************************************************
       //   test for new coming datus and classify the message
       // ***********************************************************
       public int DVM_header_check() {
        int msg_type=0;
        String dvm_signal = null ;

        System.out.println("waiting for DVM signals...");
           try {
               while(true) {
                dvm_signal = read_in.readLine();
                if(dvm_signal.length()>50) {
                    System.out.println(" signal from DVM from task " + mytsk_id + " is received: " + dvm_signal);
                    break;
                }
               } //while
          } catch(IOException e)
              { System.out.println("Error when receive information from DVM: " + e); }
               

         System.out.println("command code : " + dvm_signal.substring(dvm_signal.length()-4,dvm_signal.length()) ) ;
               if( dvm_signal.substring(0,4).equals("VDCE")  ) 
                if( dvm_signal.substring(4,8).equals("5000") )  {
                    if( dvm_signal.substring(dvm_signal.length()-4,dvm_signal.length()).equals("0002") )  msg_type=1;  // activation signal
                    else if(dvm_signal.substring(dvm_signal.length()-4,dvm_signal.length()).equals("0012") )  msg_type=2; //dvm_send_recv signal
                    else if(dvm_signal.substring(dvm_signal.length()-4,dvm_signal.length()).equals("0201") )  msg_type = 3 ; // time information
                    else if(dvm_signal.substring(dvm_signal.length()-4,dvm_signal.length()).equals("0009") )  msg_type = 9 ; // complete information
                }

         System.out.println("message from DVM : " + msg_type);
         return(msg_type);

       }
 

       // ***********************************************************
       //   Start DVM and Application
       // ***********************************************************
 
	public int Start_DVM_APP() {
            // Start local application and pass information to it.
 
            FileOutputStream fos;
            PrintStream fps=null,check=null;
            String str=null ;


            //***** set header sent to DVM  ******
            set_header();



            // **** start application *****

            System.out.println("\n Start_DVM_APP() is to be called.");
              try {
		Integer channel_no1 = new Integer(channel_no);
		Integer mytsk_id1   = new Integer(mytsk_id);

		app_dvm = Runtime.getRuntime().exec(path_file[0] + " -r " + channel_no1.toString() + " " + DVM_port + " "   + user_ID + " " + app_ID + " "  + mytsk_id1.toString() + "  master -p4pg  " + Result_Path );
            System.out.println("\n Start_DVM_APP() is called.");

                   System.out.println("***************************");
		System.out.println("application path : " + path_file[0] + " -r " + channel_no1.toString() + " " + DVM_port + " "  + user_ID + " " + app_ID + " " + mytsk_id1.toString() + "  master -p4pg  " + Result_Path );
                   System.out.println("***************************");
		//Lcvm_log.println("application path : " + path_file[0] + " -r " + channel_no1.toString() + " " + DVM_port + " "  + user_ID + " " + app_ID + " " + mytsk_id1.toString() + "  master -p4pg  " + Result_Path );

            } catch(IOException e) { System.out.println(e); }

            //**** listenning DVM_port port-****** 
              try{
                channel = serv.accept();
                System.out.println("\n local cvm listenning to information from the port " + DVM_port + " ...");
              } catch(IOException ie) { ie.printStackTrace();
                                        System.out.println("fail when listenning to DVM.");
                                      }

          System.out.println("New Connection from DVM for task " + mytsk_id + ": " + channel.getInetAddress());

          
          if(Lcvm_dvm_communication()==-1) return(-1);

          return(1);	

  }


    //  local cvm start to receive and send information between DVM
    //*******************************************************************

        public int Lcvm_dvm_communication() {
            int signal = 1 ;
            int msg_type = 0 ;
            check_stop_thread ch_t = null; 

           // ****** sent CIT ****************
           System.out.println("\n start to send CIT table...");
           send_CIT();

         // **** receive DVM message and do proper action
        while(signal == 1) {

         msg_type = DVM_header_check(); 

         switch ( msg_type ) {
           
          case 1 : 

           // ------ receive ACK -------------
           System.out.println("\n start to receive ACK from DVM ...");
           recv_ACK();

           //------- after receive ACK from DVM, send signal to server_CVM
              try{
                System.out.println("start to send 'finish' signal to server-CVM for task " + mytsk_id );
               	sout = new PrintStream(s.getOutputStream());
               	sout.println("finish");
                System.out.println("End of send 'finish' from task " + mytsk_id);
                //Lcvm_log.println("End of send 'finish' from task " + mytsk_id);
              } catch(IOException e){ System.out.println(e); }
              sout.flush();

           //------- wait for ready to start application signal from S_CVM
              try {
                    String str_ready = null;
                    str_ready = sin.readLine();
                    System.out.println("Ready signal from S-CVM : " + str_ready);
                    //Lcvm_log.println("Ready signal from S-CVM : " + str_ready);
                    if( (str_ready != null) &&  (str_ready.startsWith("ready"))  ) 
                      System.out.println("Ready to activate applications..");
                      //Lcvm_log.println("Ready to activate applications..");
                  }
               catch(IOException e) {
                 System.out.println("Ready signal from S-CVM error!"); }

           //------ connect to DVM communication channel
           System.out.println("\n start to send ACTIVATION ...");
           if(check_stop_DVM()==-1) {
             System.out.println("before activate DVM,sigal:stop");
             send_SCVM_cmplt();
             if(app_dvm != null) app_dvm.destroy();
             return(-1); }

           send_ACTIVATION();
         
           break;

          case 2 : 
           System.out.println("\n start to receive DVM send_recv information ...");
           if(check_stop_DVM()==-1) {
             System.out.println("before DVM send-recv,sigal:stop");
             send_SCVM_cmplt();
             if(app_dvm != null) app_dvm.destroy();
             return(-1); }

           recv_dvm_comm();

          
           if(check_stop_DVM()==-1) {
             System.out.println("after DVM send-recv,signal:stop");
             send_SCVM_cmplt();
             if(app_dvm != null) app_dvm.destroy();
             return(-1); }

             ch_t = new check_stop_thread(this);
            

           break;

          case 3 : 
           recv_time();  // receive time information
           // send_confm(); // send back confirmation signal to DVM

           if(check_stop_DVM()==-1) {
             System.out.println("before get time data, signal:stop");
             send_SCVM_cmplt();
             if(app_dvm != null) app_dvm.destroy();
             return(-1); }

           update_time up_t = new update_time(time_unit,exc_time,user_ID,app_ID,mytsk_id,DB_IP,DB_port);
           up_t.work(); // update time information
            if (ch_t != null && ch_t.isAlive() ) ch_t.stop();
           break;

          case 9 :
           System.out.println("\n start to receive 'complete' from task " + mytsk_id + "...");
           recv_cmplt();
           send_cmplt();
            send_SCVM_cmplt();
            signal = 0 ;  // quit loop
            if (ch_t != null && ch_t.isAlive() ) ch_t.stop();

           break;

          default :
            System.out.println("\n not VDCE signals from DVM!"); 
            signal = 0 ;

          } // switch message type 

        } // while signal == 1 
      
        return(0);
    }

   //*******************************************************
   // send "finish" signal to S-CVM
   //*******************************************************
    public void send_SCVM_cmplt() {
           //----- send "complete" signal to server-CVM
           sout.println("complete"); 
           sout.flush();
   }

   //*******************************************************
   //  close socket conection to Server_CVM and DVM
   //********************************************************
      public void close_socket()  {

           try {
                   channel.close();
                   serv.close();   // close Local_CVM server socket to DVM
           } catch(IOException e2) { System.out.println(e2); }


              
           //---- Close Socket with Server_CVM ------
		try { 
		     sin.close();
                     sout.close(); 
                     s.close();

                     //--- close log files -----
                     //main_out.close();
                     //Lcvm_log.close();

                } catch (IOException e2) {}

           try {app_dvm.waitFor();} catch(InterruptedException e) {}

    }



}
